#ifndef _KGR_PATCH_BSC1176931_H
#define _KGR_PATCH_BSC1176931_H

int kgr_patch_bsc1176931_core_init(void);
void kgr_patch_bsc1176931_core_cleanup(void);
int kgr_patch_bsc1176931_ppp_init(void);
void kgr_patch_bsc1176931_ppp_cleanup(void);
int kgr_patch_bsc1176931_eth_init(void);
void kgr_patch_bsc1176931_eth_cleanup(void);

int kgr_patch_bsc1176931_init(void);
void kgr_patch_bsc1176931_cleanup(void);


struct l2tp_tunnel;
struct l2tp_session;
struct sockaddr;
struct net;
struct l2tp_session_cfg;
struct socket;

void kgrp_l2tp_tunnel_closeall(struct l2tp_tunnel *tunnel);
int kgrp_l2tp_session_delete(struct l2tp_session *session);

void kgrp_pppol2tp_session_close(struct l2tp_session *session);
int kgrp_pppol2tp_connect(struct socket *sock, struct sockaddr *uservaddr,
			    int sockaddr_len, int flags);
int kgrp_pppol2tp_session_create(struct net *net, u32 tunnel_id, u32 session_id, u32 peer_session_id, struct l2tp_session_cfg *cfg);
int kgrp_pppol2tp_ioctl(struct socket *sock, unsigned int cmd,
			  unsigned long arg);
int kgrp_pppol2tp_getname(struct socket *sock, struct sockaddr *uaddr,
			    int *usockaddr_len, int peer);

int kgrp_l2tp_eth_create(struct net *net, u32 tunnel_id, u32 session_id, u32 peer_session_id, struct l2tp_session_cfg *cfg);

#define KGR_PATCH_BSC1176931_FUNCS		\
	KGR_PATCH_OBJ(l2tp_tunnel_closeall, kgrp_l2tp_tunnel_closeall,	\
		      "l2tp_core"),					\
	KGR_PATCH_OBJ(l2tp_session_delete, kgrp_l2tp_session_delete,	\
		      "l2tp_core"),					\
	KGR_PATCH_OBJ(pppol2tp_session_close,				\
		      kgrp_pppol2tp_session_close, "l2tp_ppp"),	\
	KGR_PATCH_OBJ(pppol2tp_connect, kgrp_pppol2tp_connect,		\
		      "l2tp_ppp"),					\
	KGR_PATCH_OBJ(pppol2tp_session_create,				\
		      kgrp_pppol2tp_session_create, "l2tp_ppp"),	\
	KGR_PATCH_OBJ(pppol2tp_ioctl, kgrp_pppol2tp_ioctl,		\
		      "l2tp_ppp"),					\
	KGR_PATCH_OBJ(pppol2tp_getname, kgrp_pppol2tp_getname,		\
		      "l2tp_ppp"),					\
	KGR_PATCH_OBJ(l2tp_eth_create, kgrp_l2tp_eth_create,		\
		      "l2tp_eth"),					\


#endif /* _KGR_PATCH_BSC1176931_H */
